Subject: bug#68660: 29.2; ELPA: Wrong type argument w. multiple maintainers in package-menu-mode

From: Philip Kaludercic <[email-masked]>
Date: Wed, 14 Feb 2024 16:59:19 +0000

"J.P." <[email-masked]> writes:

> Hi Philip,
>
> "J.P." <[email-masked]> writes:
>
>>>> Please let me know if anything is required from ERC to make this a
>>>> reality. And, of course, I very much appreciate your taking the time.
>>>
>>> Nothing specific on ERC's side, no.
>>> But patches for `elpa-admin.el` and for Emacs would be welcome
>>> (tho extra time would be welcome as well :-)
>>
>> As far as patches go, I unfortunately remain rather uninitiated to the
>> mysteries of this package system and doubt I can up my game
>> sufficiently
>> enough to amount to anything more than a sad annoyance. However, I can
>> try harassing other package.el folk to see if any among them might
>> bend.
>> Thanks.
>
> You seem to be among the more active Emacs contributors in and around
> package.el and GNU ELPA, so I suppose I'm asking if you wouldn't mind
> weighing in on this when you get a chance.
>
> To summarize, I've belatedly discovered that once ERC 5.6 is released,
> the more-or-less widely acknowledged [1] "baseline" package-upgrade
> method (of manually navigating the `package-menu-mode' UI from M-x
> list-packages) won't actually work on any ERC-supported Emacs release
> (currently 27+) even though it's the one method recommended in ERC's
> docs (expressly because it was perceived as being fail-safe). And while
> C-u M-x package-install RET does in fact work on Emacs 29, it's sadly
> not documented in the ERC manual that ships with 29.2.
>
> Stefan has suggested renaming the `:maintainer' item in the `extras'
> slot of `package-desc' objects to `:maintainers' (plural). IIUC, this
> would have the effect of solving the issue by omitting the "Maintainer:"
> line item in *Help* buffers produced by `package-menu-describe-package'
> and friends for all packages on all Emacs versions below 30.1. 

That also seems to be the best idea to me as well.

>                                                                Full
> remediation would, I think, also require that foo-pkg.el files and
> /archive-contents data hosted on elpa.gnu.org reflect the newer format.

I am not familiar with ERC's infrastructure, shouldn't this happen
automatically?

> To help move this process along, Stefan has called for patches, but I
> unfortunately am unable to reciprocate because I lack the wherewithal.
> Hoping you're able to assist in this regard either directly, with code,
> or by pointing out specific areas in the Emacs code base (and possibly
> elpa-admin's as well) that would need addressing.

I could help, but I don't understand what is going on well enough to
produce any concrete patches.

> TIA,
> J.P.
>
> [1]
> https://lists.gnu.org/archive/html/bug-gnu-emacs/2024-01/msg01575.html